 Patch taken from https://git.launchpad.net/ubuntu/+source/partman-auto-lvm/commit/?h=ubuntu/bionic-devel&id=dcec1c5332933f289e4f53e2145e20d70fdbdc30

 - Explicitly use C locale when getteing data from vgs
 - Allow restricting use of VG to a size or percentage (guided_size option)
 - Aadd available translations for the relevant debconf templates

diff -urN partman-auto-lvm-68.orig/automatically_partition/some_device_lvm/do_option partman-auto-lvm-68/automatically_partition/some_device_lvm/do_option
--- partman-auto-lvm-68.orig/automatically_partition/some_device_lvm/do_option	2018-07-22 04:30:58.565947485 +0200
+++ partman-auto-lvm-68/automatically_partition/some_device_lvm/do_option	2018-07-22 04:31:39.137613004 +0200
@@ -9,4 +9,10 @@
 	autopartition-lvm "$disk"
 	code=$?
 done
-exit $code
+
+if [ $code -ne 0 ]; then
+	exit $code
+else
+	# accept the autopartitioning
+	exit 100
+fi
diff -urN partman-auto-lvm-68.orig/debian/partman-auto-lvm.templates partman-auto-lvm-68/debian/partman-auto-lvm.templates
--- partman-auto-lvm-68.orig/debian/partman-auto-lvm.templates	2018-07-22 04:30:58.565947485 +0200
+++ partman-auto-lvm-68/debian/partman-auto-lvm.templates	2018-07-22 04:31:39.137613004 +0200
@@ -73,3 +73,41 @@
  volume group that does not contain any physical volume.
  .
  Please check the automatic partitioning recipe.
+
+Template: partman-auto-lvm/guided_size
+Type: string
+Default: some number
+# :sl3:
+_Description: Amount of volume group to use for guided partitioning:
+ You may use the whole volume group for guided partitioning, or part of it.
+ If you use only part of it, or if you add more disks later, then you will
+ be able to grow logical volumes later using the LVM tools, so using a
+ smaller part of the volume group at installation time may offer more
+ flexibility.
+ .
+ The minimum size of the selected partitioning recipe is ${MINSIZE} (or
+ ${PERCENT}); please note that the packages you choose to install may
+ require more space than this. The maximum available size is ${MAXSIZE}.
+ .
+ Hint: "max" can be used as a shortcut to specify the maximum size, or
+ enter a percentage (e.g. "20%") to use that percentage of the maximum size.
+
+Template: partman-auto-lvm/bad_guided_size
+Type: error
+# :sl3:
+_Description: Invalid input
+ You entered "${INPUT}", which was not recognized as a valid size.
+
+Template: partman-auto-lvm/big_guided_size
+Type: error
+# :sl3:
+_Description: ${SIZE} is too big
+ You asked for ${SIZE} to be used for guided partitioning, but the available
+ space is only ${MAXSIZE}.
+
+Template: partman-auto-lvm/small_guided_size
+Type: error
+# :sl3:
+_Description: ${SIZE} is too small
+ You asked for ${SIZE} to be used for guided partitioning, but the selected
+ partitioning recipe requires at least ${MINSIZE}.
diff -urN partman-auto-lvm-68.orig/debian/po/et.po.rej partman-auto-lvm-68/debian/po/et.po.rej
--- partman-auto-lvm-68.orig/debian/po/et.po.rej	1970-01-01 01:00:00.000000000 +0100
+++ partman-auto-lvm-68/debian/po/et.po.rej	2018-07-22 04:31:39.145612938 +0200
@@ -0,0 +1,103 @@
+--- debian/po/et.po
++++ debian/po/et.po
+@@ -217,3 +217,100 @@ msgstr ""
+ #: ../partman-auto-lvm.templates:10001
+ msgid "Please check the automatic partitioning recipe."
+ msgstr "Palun kontrolli automaatse partitsioneerimise plaani"
++
++#. Type: string
++#. Description
++#. :sl3:
++#: ../partman-auto-lvm.templates:11001
++msgid "Amount of volume group to use for guided partitioning:"
++msgstr "Köitegrupi maht, mida kasutatakse juhitud partitsioneerimise jaoks:"
++
++#. Type: string
++#. Description
++#. :sl3:
++#: ../partman-auto-lvm.templates:11001
++msgid ""
++"You may use the whole volume group for guided partitioning, or part of it. "
++"If you use only part of it, or if you add more disks later, then you will be "
++"able to grow logical volumes later using the LVM tools, so using a smaller "
++"part of the volume group at installation time may offer more flexibility."
++msgstr ""
++"Juhitud partitsioneerimise jaoks võid kasutada kogu köitegruppi või selle "
++"osa. Kui kasutad ainult osa, või kui lisad hiljem kettaid, saad loogilisi "
++"köiteid LVM-tööriistadega hiljem kasvatada, seega annab paigaldamisel "
++"väiksema köitegrupi kasutamine suurema paindlikkuse."
++
++#. Type: string
++#. Description
++#. :sl3:
++#: ../partman-auto-lvm.templates:11001
++msgid ""
++"The minimum size of the selected partitioning recipe is ${MINSIZE} (or "
++"${PERCENT}); please note that the packages you choose to install may require "
++"more space than this. The maximum available size is ${MAXSIZE}."
++msgstr ""
++"Valitud partitsiooniskeemi vähim suurus on ${MINSIZE} (või ${PERCENT}); pane "
++"tähele, et kui sa tahad rohkem pakke paigaldada, läheb selle jaoks rohkem "
++"ruumi vaja. Suurim saadaolev ruum on ${MAXSIZE}."
++
++#. Type: string
++#. Description
++#. :sl3:
++#: ../partman-auto-lvm.templates:11001
++#, no-c-format
++msgid ""
++"Hint: \"max\" can be used as a shortcut to specify the maximum size, or "
++"enter a percentage (e.g. \"20%\") to use that percentage of the maximum size."
++msgstr ""
++"Vihje: \"max\" on otsetee suurimale võimalikule suurusele, võib sisestada ka "
++"protsendi (nt \"20%\") et kasutada osa suurimast võimalikust suurusest."
++
++#. Type: error
++#. Description
++#. :sl3:
++#: ../partman-auto-lvm.templates:12001
++msgid "Invalid input"
++msgstr "Vigane sisend"
++
++#. Type: error
++#. Description
++#. :sl3:
++#: ../partman-auto-lvm.templates:12001
++msgid "You entered \"${INPUT}\", which was not recognized as a valid size."
++msgstr "Sisestasid \"${INPUT}\", mis ei ole sobiv suurus."
++
++#. Type: error
++#. Description
++#. :sl3:
++#: ../partman-auto-lvm.templates:13001
++msgid "${SIZE} is too big"
++msgstr "${SIZE} on liiga suur"
++
++#. Type: error
++#. Description
++#. :sl3:
++#: ../partman-auto-lvm.templates:13001
++msgid ""
++"You asked for ${SIZE} to be used for guided partitioning, but the available "
++"space is only ${MAXSIZE}."
++msgstr ""
++"Valisid juhitud partitsioneerimise jaoks ${SIZE}, kuid saadaval on ainult "
++"${MAXSIZE}."
++
++#. Type: error
++#. Description
++#. :sl3:
++#: ../partman-auto-lvm.templates:14001
++msgid "${SIZE} is too small"
++msgstr "${SIZE} on liiga väike"
++
++#. Type: error
++#. Description
++#. :sl3:
++#: ../partman-auto-lvm.templates:14001
++msgid ""
++"You asked for ${SIZE} to be used for guided partitioning, but the selected "
++"partitioning recipe requires at least ${MINSIZE}."
++msgstr ""
++"Valisid juhitud partitsioneerimise jaoks ${SIZE}, kuid valitud "
++"partitsiooniskeem vajab vähemalt ${MINSIZE}."
diff -urN partman-auto-lvm-68.orig/perform_recipe_by_lvm partman-auto-lvm-68/perform_recipe_by_lvm
--- partman-auto-lvm-68.orig/perform_recipe_by_lvm	2018-07-22 04:30:58.565947485 +0200
+++ partman-auto-lvm-68/perform_recipe_by_lvm	2018-07-22 04:31:39.161612806 +0200
@@ -32,7 +32,7 @@
 # lvm overhead gets calculated properly only using kbytes.
 # Switch to that. The worst scenario is that the last partition will
 # be one PE smaller, but in the big numbers it's nothing (4MB).
-free_size=$(vgs -o vg_free --units K --noheading --nosuffix $VG_name | sed -e 's/^[[:space:]]*//; s/\..*//g')
+free_size=$(LC_ALL=C vgs -o vg_free --units K --noheading --nosuffix $VG_name | sed -e 's/^[[:space:]]*//; s/\..*//g')
 
 newscheme=''
 foreach_partition '
@@ -52,6 +52,92 @@
 
 db_progress STEP 1
 
+# free_size and everything in the scheme are now in (decimal) kilobytes. For
+# conversion to human numbers, we need another multiple of 1000.
+minsize="$(min_size)"
+hminsize="$(longint2human "$minsize"000)"
+hmaxsize="$(longint2human "$free_size"000)"
+minsize_rounded="$(human2longint "$hminsize")"
+maxsize_rounded="$(human2longint "$hmaxsize")"
+minpercent="$(expr 100 \* "$minsize" / "$free_size")"
+
+guided_size=
+while [ -z "$guided_size" ]; do
+	db_fget partman-auto-lvm/guided_size seen
+	if [ "$RET" = false ]; then
+		db_set partman-auto-lvm/guided_size "$hmaxsize"
+	fi
+	db_subst partman-auto-lvm/guided_size MINSIZE "$hminsize"
+	db_subst partman-auto-lvm/guided_size MAXSIZE "$hmaxsize"
+	db_subst partman-auto-lvm/guided_size PERCENT "$minpercent%"
+	db_input high partman-auto-lvm/guided_size || true
+	db_go || return 255
+
+	db_get partman-auto-lvm/guided_size
+	case $RET in
+	    max)
+		guided_size="$free_size"000
+		;;
+	    *%)
+		digits="$(expr "$RET" : '\([1-9][0-9]*\) *%$')"
+		if [ "$digits" ]; then
+			maxmb="$(convert_to_megabytes "$free_size"000)"
+			guided_size="$(($digits * $maxmb / 100))000000"
+		fi
+		;;
+	    *)
+		if valid_human "$RET"; then
+			guided_size="$(human2longint "$RET")"
+		fi
+		;;
+	esac
+
+	if [ -z "$guided_size" ]; then
+		db_subst partman-auto-lvm/bad_guided_size INPUT "$RET"
+		db_input high partman-auto-lvm/bad_guided_size || true
+		db_go || true
+	elif ! longint_le "$guided_size" "$free_size"000; then
+		if longint_le "$guided_size" "$maxsize_rounded"; then
+			guided_size="$free_size"000
+		else
+			db_subst partman-auto-lvm/big_guided_size SIZE \
+				"$(longint2human "$guided_size")"
+			db_subst partman-auto-lvm/big_guided_size MAXSIZE \
+				"$hmaxsize"
+			db_input high partman-auto-lvm/big_guided_size || true
+			db_go || true
+			guided_size=
+		fi
+	elif ! longint_le "$minsize"000 "$guided_size"; then
+		if longint_le "$minsize_rounded" "$guided_size"; then
+			guided_size="$minsize"000
+		else
+			db_subst partman-auto-lvm/small_guided_size SIZE \
+				"$(longint2human "$guided_size")"
+			db_subst partman-auto-lvm/small_guided_size MINSIZE \
+				"$hminsize"
+			db_input high partman-auto-lvm/small_guided_size || true
+			db_go || true
+			guided_size=
+		fi
+	fi
+
+	if [ "$guided_size" ]; then
+		# We have a figure in (decimal) megabytes. Convert back to
+		# (decimal) kilobytes, which is what the rest of this is
+		# expecting.
+		guided_size="$(expr 0000"$guided_size" : '0*\(..*\)...$')"
+	else
+		db_fset partman-auto-lvm/guided_size seen false
+	fi
+done
+
+use_all=
+if [ "$guided_size" -ge "$free_size" ]; then
+	use_all=1
+fi
+free_size="$guided_size"
+
 expand_scheme
 
 db_progress STEP 1
@@ -86,7 +172,7 @@
 		name_number=$(($name_number + 1))
 	fi
 
-	if [ "$last" = yes ]; then
+	if [ "$last" = yes ] && [ "$use_all" ]; then
 		vg_get_info "$VG_name"
 		lv_create $VG_name "$lvname" $FREEPE || autopartitioning_failed
 	else
